"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.AbstractModeFill = undefined;

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _PathDrawer = require("./PathDrawer");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AbstractModeFill = exports.AbstractModeFill = function () {
    function AbstractModeFill(viewer, tran, prop) {
        (0, _classCallCheck3.default)(this, AbstractModeFill);

        this.viewer = viewer;
        this.tran = tran;
        this.tran.setSavePoint();
        this.pathDrawer = new _PathDrawer.PathDrawer(tran, prop);
        this.lPointX = -100;
        this.lPointY = -100;
    }

    (0, _createClass3.default)(AbstractModeFill, [{
        key: "touchStart",
        value: function touchStart(x, y) {
            this.touchMove(x, y);
        }
    }, {
        key: "touchMove",
        value: function touchMove(x, y) {
            if (!this.tran.isAlive()) {
                return;
            }
            var latest = this.time;
            this.time = new Date().getTime();
            if (this.time - latest >= 50) {
                // this.tran.restoreSavePoint();
                this.doFill(x, y);
                return;
            }
            var x1 = x - this.lPointX;
            var y1 = y - this.lPointY;
            var d = Math.sqrt(x1 * x1 + y1 * y1);
            if (d < 5) {
                this.wPointX = x;
                this.wPointY = y;
                this.setWait();
                return;
            }
            this.doFill(x, y);
        }
    }, {
        key: "touchEnd",
        value: function touchEnd(x, y) {
            this.touchMove(x, y);
        }
    }, {
        key: "setWait",
        value: function setWait() {
            var _this = this;

            if (this.waiting) {
                return;
            }
            this.waiting = true;
            setTimeout(function () {
                if (!_this.waiting) {
                    return;
                }
                _this.waiting = false;
                if (!_this.tran.isAlive()) {
                    return;
                }
                var now = new Date().getTime();
                if (now - _this.time < 100) {
                    _this.setWait();
                    return;
                }
                _this.doFill(_this.wPointX, _this.wPointY);
            }, 100);
        }
    }, {
        key: "doFill",
        value: function doFill(x, y) {
            this.waiting = false;
            this.lPointX = x;
            this.lPointY = y;
            this.viewer.stop();
            try {
                this.tran.restoreSavePoint();
                this.setProperty(this.tran);
                if (x < 0 && y < 0) {
                    this.pathDrawer.doPlot(true);
                    return;
                }
                this.pathDrawer.push(this.lPointX, this.lPointY).doPlot(true);
            } finally {
                this.tran.flush();
                this.viewer.start();
            }
        }
    }, {
        key: "setText",
        value: function setText(text) {
            // 処理なし。
        }
    }, {
        key: "backward",
        value: function backward() {
            this.pathDrawer.pop();
            var point = this.pathDrawer.pop();
            if (point != null) {
                point = {
                    x: -100,
                    y: -100
                };
            }
            this.doFill(point.x, point.y);
        }
    }]);
    return AbstractModeFill;
}();
//# sourceMappingURL=AbstractModeFill.js.map
