import * as drawchat from "@s2study/draw-api";
import DrawchatCanvas = drawchat.editor.DrawEditorCanvas;
import PathTransaction = drawchat.updater.PathTransaction;
import DrawchatViewer = drawchat.viewer.DrawchatViewer;
import { EditorProperties } from "./EditorProperties";
export declare abstract class AbstractModeStroke<T extends PathTransaction> implements DrawchatCanvas {
    private viewer;
    private tran;
    private pathDrawer;
    constructor(viewer: DrawchatViewer, tran: T, prop: EditorProperties);
    private time;
    lPointX: number;
    lPointY: number;
    private wPointX;
    private wPointY;
    private waiting;
    private reset;
    private commitReserve;
    private started;
    touchStart(x: number, y: number): void;
    touchMove(x: number, y: number): void;
    touchEnd(x: number, y: number): void;
    private checkLastAccess();
    private setWait();
    private doStroke(x, y);
    protected abstract setCommitProperty(tran: T): void;
    protected abstract setProperty(tran: T): void;
    setText(text: string): void;
    backward(): void;
}
