"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.AbstractModeStroke = undefined;

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _PathDrawer = require("./PathDrawer");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AbstractModeStroke = exports.AbstractModeStroke = function () {
    function AbstractModeStroke(viewer, tran, prop) {
        (0, _classCallCheck3.default)(this, AbstractModeStroke);

        this.viewer = viewer;
        this.tran = tran;
        this.tran.setSavePoint();
        this.pathDrawer = new _PathDrawer.PathDrawer(tran, prop);
        this.lPointX = -100;
        this.lPointY = -100;
    }

    (0, _createClass3.default)(AbstractModeStroke, [{
        key: "touchStart",
        value: function touchStart(x, y) {
            if (!this.tran.isAlive()) {
                return;
            }
            this.checkLastAccess();
            this.tran.setSavePoint();
            this.pathDrawer.clear();
            this.doStroke(x, y);
            this.started = true;
        }
    }, {
        key: "touchMove",
        value: function touchMove(x, y) {
            if (!this.tran.isAlive()) {
                return;
            }
            this.checkLastAccess();
            var latest = this.time;
            this.time = new Date().getTime();
            if (this.time - latest >= 50) {
                this.doStroke(x, y);
                return;
            }
            var x1 = x - this.lPointX;
            var y1 = y - this.lPointY;
            var d = Math.sqrt(x1 * x1 + y1 * y1);
            if (d < 50) {
                this.time = latest;
                this.wPointX = x;
                this.wPointY = y;
                this.setWait();
                return;
            }
            this.doStroke(x, y);
        }
    }, {
        key: "touchEnd",
        value: function touchEnd(x, y) {
            if (!this.started) {
                return;
            }
            this.started = false;
            if (!this.tran.isAlive()) {
                return;
            }
            this.checkLastAccess();
            if (this.lPointX === x && this.lPointY === y) {
                this.setCommitProperty(this.tran);
                this.tran.commit(true);
                this.pathDrawer.clear();
                return;
            }
            this.time = new Date().getTime();
            this.doStroke(x, y);
            this.setCommitProperty(this.tran);
            this.tran.commit(true);
            this.pathDrawer.clear();
        }
    }, {
        key: "checkLastAccess",
        value: function checkLastAccess() {
            var _this = this;

            if (this.commitReserve) {
                this.reset = true;
                return;
            }
            this.commitReserve = true;
            setTimeout(function () {
                if (_this.reset) {
                    _this.reset = false;
                    _this.checkLastAccess();
                    return;
                }
                _this.commitReserve = false;
                _this.setCommitProperty(_this.tran);
                _this.tran.commit(true);
                _this.pathDrawer.clear();
            }, 1000);
        }
    }, {
        key: "setWait",
        value: function setWait() {
            var _this2 = this;

            if (this.waiting) {
                return;
            }
            this.waiting = true;
            setTimeout(function () {
                if (!_this2.waiting) {
                    return;
                }
                _this2.waiting = false;
                if (!_this2.tran.isAlive()) {
                    return;
                }
                var now = new Date().getTime();
                if (now - _this2.time < 100) {
                    _this2.setWait();
                    return;
                }
                _this2.doStroke(_this2.wPointX, _this2.wPointY);
            }, 100);
        }
    }, {
        key: "doStroke",
        value: function doStroke(x, y) {
            this.viewer.stop();
            try {
                this.waiting = false;
                this.lPointX = x;
                this.lPointY = y;
                this.tran.restoreSavePoint();
                this.setProperty(this.tran);
                this.pathDrawer.push(this.lPointX, this.lPointY).doPlot(false, false);
            } finally {
                this.tran.flush();
                this.viewer.start();
            }
        }
    }, {
        key: "setText",
        value: function setText(text) {
            // 処理なし。
        }
    }, {
        key: "backward",
        value: function backward() {
            // 処理なし。
        }
    }]);
    return AbstractModeStroke;
}();
//# sourceMappingURL=AbstractModeStroke.js.map
