import * as drawchat from "@s2study/draw-api";
import DrawchatModeChanger = drawchat.editor.DrawEditorModeChanger;
import DrawchatCanvas = drawchat.editor.DrawEditorCanvas;
import { Layers } from "./Layers";
import { EditorProperties } from "./EditorProperties";
import { EditorEventDispatchers } from "./EditorEventDispatchers";
export declare class Changer implements DrawchatModeChanger {
    private static EMPTY_CANVAS;
    /**
     * モードチェンジ中
     */
    readonly CHANGING: number;
    /**
     * 消しゴムツールを示す定数
     */
    readonly ERASER_MODE: number;
    /**
     * 塗りツールを示す定数
     */
    readonly FILL_MODE: number;
    /**
     * 線ツールを示す定数
     */
    readonly STROKE_MODE: number;
    /**
     * クリップツールを示す定数
     */
    readonly CLIP_MODE: number;
    /**
     * テキストツールを示す定数
     */
    readonly TEXT_MODE: number;
    /**
     * 変形ツールを示す定数
     */
    readonly HAND_TOOL_MODE: number;
    /**
     * スポイトツールを示す定数
     */
    readonly EYEDROPPER_MODE: number;
    private updater;
    private layers;
    private prop;
    private viewer;
    private dispatcher;
    constructor(layers: Layers, prop: EditorProperties, dispatcher: EditorEventDispatchers);
    private mode;
    private reservedMode;
    canvas: DrawchatCanvas;
    getMode(): number;
    changeMode(mode: number): Promise<any>;
    isAliveMode(mode: Number): boolean;
    private doChangeMode(mode, canvas);
}
