import * as api from "@s2study/draw-api";
import DrawchatEditor = api.editor.DrawEditor;
import DrawchatEditorProperties = api.editor.DrawEditorProperties;
import DrawchatCanvas = api.editor.DrawEditorCanvas;
import DrawchatModeChanger = api.editor.DrawEditorModeChanger;
import DrawHistory = api.history.DrawHistory;
import DrawchatRenderer = api.renderer.DrawchatRenderer;
import DrawEditorEventListeners = api.editor.DrawEditorEventListeners;
import Message = api.structures.Message;
import { Layers } from "./Layers";
import { Changer } from "./Changer";
import { EditorProperties } from "./EditorProperties";
import { EditorEventDispatchers } from "./EditorEventDispatchers";
export declare class Editor implements DrawchatEditor {
    /**
     * 設定値
     */
    _properties: EditorProperties;
    /**
     * モードチェンジャー
     */
    _mode: Changer;
    layers: Layers;
    private history;
    private updater;
    private renderer;
    private viewer;
    private _listeners;
    private _dispatchers;
    constructor(history: DrawHistory, renderer: DrawchatRenderer, properties?: DrawchatEditorProperties);
    readonly properties: DrawchatEditorProperties;
    readonly canvas: DrawchatCanvas;
    readonly mode: DrawchatModeChanger;
    readonly events: DrawEditorEventListeners;
    readonly dispatchers: EditorEventDispatchers;
    stop(): void;
    start(): void;
    getWidth(): number;
    getHeight(): number;
    undo(): Promise<any>;
    redo(): Promise<any>;
    canUndo(): boolean;
    canRedo(): boolean;
    reRender(): void;
    private setupListener();
    createImageURI(): Promise<string>;
    generateMessage(): Promise<Message>;
}
