"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.EventDispatcher = exports.EditorEventDispatchers = undefined;

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _EditorEventListeners = require("./EditorEventListeners");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var EditorEventDispatchers = exports.EditorEventDispatchers = function () {
    function EditorEventDispatchers(eventEmitter) {
        (0, _classCallCheck3.default)(this, EditorEventDispatchers);

        this._changeProperties = new EventDispatcher(eventEmitter, _EditorEventListeners.EVENT_CHANGE_PROPERTIES);
        this._changeMode = new EventDispatcher(eventEmitter, _EditorEventListeners.EVENT_CHANGE_MODE);
        this._changeCurrentLayer = new EventDispatcher(eventEmitter, _EditorEventListeners.EVENT_CHANGE_CURRENT_LAYER);
        this._update = new EventDispatcher(eventEmitter, _EditorEventListeners.EVENT_UPDATE);
    }

    (0, _createClass3.default)(EditorEventDispatchers, [{
        key: "changeProperties",
        get: function get() {
            return this._changeProperties;
        }
    }, {
        key: "changeMode",
        get: function get() {
            return this._changeMode;
        }
    }, {
        key: "changeCurrentLayer",
        get: function get() {
            return this._changeCurrentLayer;
        }
    }, {
        key: "update",
        get: function get() {
            return this._update;
        }
    }]);
    return EditorEventDispatchers;
}();

var EventDispatcher = exports.EventDispatcher = function () {
    function EventDispatcher(emitter3, eventName) {
        (0, _classCallCheck3.default)(this, EventDispatcher);

        this.eventName = eventName;
        this.emitter3 = emitter3;
    }

    (0, _createClass3.default)(EventDispatcher, [{
        key: "dispatch",
        value: function dispatch(val) {
            this.emitter3.emit(this.eventName, val);
        }
    }]);
    return EventDispatcher;
}();
//# sourceMappingURL=EditorEventDispatchers.js.map
