import * as api from "@s2study/draw-api";
import Update = api.editor.Update;
import ChangeCurrentLayer = api.editor.ChangeCurrentLayer;
import ModeChange = api.editor.ModeChange;
import ChangeProperties = api.editor.ChangeProperties;
import * as emitter from "eventemitter3";
export declare const EVENT_CHANGE_PROPERTIES: string;
export declare const EVENT_CHANGE_MODE: string;
export declare const EVENT_CHANGE_CURRENT_LAYER: string;
export declare const EVENT_UPDATE: string;
export declare class EditorEventListeners implements api.editor.DrawEditorEventListeners {
    private _changeProperties;
    private _changeMode;
    private _changeCurrentLayer;
    private _update;
    constructor(eventEmitter: emitter.EventEmitter);
    /**
     * プロパティ変更通知
     */
    readonly changeProperties: ChangeProperties;
    /**
     * 編集モード編集通知
     */
    readonly changeMode: ModeChange;
    /**
     * 編集レイヤー変更通知
     */
    readonly changeCurrentLayer: ChangeCurrentLayer;
    /**
     * 更新通知
     */
    readonly update: Update;
}
