"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.EditorEventListeners = exports.EVENT_UPDATE = exports.EVENT_CHANGE_CURRENT_LAYER = exports.EVENT_CHANGE_MODE = exports.EVENT_CHANGE_PROPERTIES = undefined;

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var EVENT_CHANGE_PROPERTIES = exports.EVENT_CHANGE_PROPERTIES = "changeProperties";
var EVENT_CHANGE_MODE = exports.EVENT_CHANGE_MODE = "changeMode";
var EVENT_CHANGE_CURRENT_LAYER = exports.EVENT_CHANGE_CURRENT_LAYER = "changeCurrentLayer";
var EVENT_UPDATE = exports.EVENT_UPDATE = "update";

var EditorEventListeners = exports.EditorEventListeners = function () {
    function EditorEventListeners(eventEmitter) {
        (0, _classCallCheck3.default)(this, EditorEventListeners);

        this._changeProperties = new EventListenerImpl(this, eventEmitter, EVENT_CHANGE_PROPERTIES);
        this._changeMode = new EventListenerImpl(this, eventEmitter, EVENT_CHANGE_MODE);
        this._changeCurrentLayer = new EventListenerImpl(this, eventEmitter, EVENT_CHANGE_CURRENT_LAYER);
        this._update = new EventListenerImpl(this, eventEmitter, EVENT_UPDATE);
    }
    /**
     * プロパティ変更通知
     */


    (0, _createClass3.default)(EditorEventListeners, [{
        key: "changeProperties",
        get: function get() {
            return this._changeProperties;
        }
        /**
         * 編集モード編集通知
         */

    }, {
        key: "changeMode",
        get: function get() {
            return this._changeMode;
        }
        /**
         * 編集レイヤー変更通知
         */

    }, {
        key: "changeCurrentLayer",
        get: function get() {
            return this._changeCurrentLayer;
        }
        /**
         * 更新通知
         */

    }, {
        key: "update",
        get: function get() {
            return this._update;
        }
    }]);
    return EditorEventListeners;
}();

var EventListenerImpl = function () {
    function EventListenerImpl(eventListeners, eventEmitter, eventName) {
        (0, _classCallCheck3.default)(this, EventListenerImpl);

        this.eventEmitter = eventEmitter;
        this.eventName = eventName;
        this.eventListeners = eventListeners;
    }

    (0, _createClass3.default)(EventListenerImpl, [{
        key: "on",
        value: function on(listener) {
            this.eventEmitter.on(this.eventName, listener);
            return this.eventListeners;
        }
    }, {
        key: "once",
        value: function once(listener) {
            this.eventEmitter.once(this.eventName, listener);
            return this.eventListeners;
        }
    }, {
        key: "off",
        value: function off(listener) {
            this.eventEmitter.off(this.eventName, listener);
            return this.eventListeners;
        }
    }]);
    return EventListenerImpl;
}();
//# sourceMappingURL=EditorEventListeners.js.map
