import * as drawchat from "@s2study/draw-api";
import DrawchatEditorProperties = drawchat.editor.DrawEditorProperties;
import Color = drawchat.editor.Color;
import { EditorEventDispatchers } from "./EditorEventDispatchers";
export declare class EditorProperties implements DrawchatEditorProperties {
    private dispatcher;
    /**
     * 線の色
     */
    _color: Color;
    color: Color;
    /**
     * 線の太さ
     */
    _thickness: number;
    thickness: number;
    /**
     * フォントサイズ
     */
    _fontSize: number;
    fontSize: number;
    /**
     * フォントファミリー
     */
    _fontFamily: string;
    fontFamily: string;
    /**
     * フォントの太さ
     */
    _fontWeight: number;
    fontWeight: number;
    /**
     * フォントスタイル
     */
    _fontStyle: string;
    fontStyle: string;
    /**
     * アルファ値
     */
    _alpha: number;
    alpha: number;
    /**
     * パスの種別
     * 0: moveTo
     * 1: arcTo
     * 2: quadraticCurveTo
     * 3: lineTo
     * 4: bezierCurveTo
     */
    _pathType: number;
    pathType: number;
    constructor(dispatcher: EditorEventDispatchers, initProps?: DrawchatEditorProperties);
    private setDefault();
}
