"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.EditorProperties = undefined;

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var EditorProperties = exports.EditorProperties = function () {
    function EditorProperties(dispatcher, initProps) {
        (0, _classCallCheck3.default)(this, EditorProperties);

        this.dispatcher = dispatcher;
        if (initProps == null) {
            this.setDefault();
            return;
        }
        this._color = initProps.color;
        this._pathType = initProps.pathType;
        this._alpha = initProps.alpha;
        this._fontStyle = initProps.fontStyle;
        this._fontWeight = initProps.fontWeight;
        this._fontFamily = initProps.fontFamily;
        this._fontSize = initProps.fontSize;
        this._thickness = initProps.thickness;
    }

    (0, _createClass3.default)(EditorProperties, [{
        key: "setDefault",
        value: function setDefault() {
            this._color = new ColorImpl();
            this._pathType = 0;
            this._alpha = 1.0;
            this._fontStyle = null;
            this._fontWeight = 400;
            this._fontFamily = "sans-serif";
            this._fontSize = 24;
            this._thickness = 12;
        }
    }, {
        key: "color",
        get: function get() {
            return this._color;
        },
        set: function set(val) {
            this._color = val;
            this.dispatcher.changeProperties.dispatch(this);
        }
    }, {
        key: "thickness",
        get: function get() {
            return this._thickness;
        },
        set: function set(val) {
            this._thickness = val;
            this.dispatcher.changeProperties.dispatch(this);
        }
    }, {
        key: "fontSize",
        get: function get() {
            return this._fontSize;
        },
        set: function set(val) {
            this._fontSize = val;
            this.dispatcher.changeProperties.dispatch(this);
        }
    }, {
        key: "fontFamily",
        get: function get() {
            return this._fontFamily;
        },
        set: function set(val) {
            this._fontFamily = val;
            this.dispatcher.changeProperties.dispatch(this);
        }
    }, {
        key: "fontWeight",
        get: function get() {
            return this._fontWeight;
        },
        set: function set(val) {
            this._fontWeight = val;
            this.dispatcher.changeProperties.dispatch(this);
        }
    }, {
        key: "fontStyle",
        get: function get() {
            return this._fontStyle;
        },
        set: function set(val) {
            this._fontStyle = val;
            this.dispatcher.changeProperties.dispatch(this);
        }
    }, {
        key: "alpha",
        get: function get() {
            return this._alpha;
        },
        set: function set(val) {
            this._alpha = val;
            this.dispatcher.changeProperties.dispatch(this);
        }
    }, {
        key: "pathType",
        get: function get() {
            return this._pathType;
        },
        set: function set(val) {
            this._pathType = val;
            this.dispatcher.changeProperties.dispatch(this);
        }
    }]);
    return EditorProperties;
}();

var ColorImpl = function () {
    function ColorImpl() {
        var r = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
        var g = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
        var b = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
        (0, _classCallCheck3.default)(this, ColorImpl);

        this.r = r;
        this.g = g;
        this.b = b;
    }

    (0, _createClass3.default)(ColorImpl, [{
        key: "r",
        set: function set(val) {
            this._r = ColorImpl.correctColor(val);
        },
        get: function get() {
            return this._r;
        }
    }, {
        key: "g",
        set: function set(val) {
            this._g = ColorImpl.correctColor(val);
        },
        get: function get() {
            return this._g;
        }
    }, {
        key: "b",
        set: function set(val) {
            this._b = ColorImpl.correctColor(val);
        },
        get: function get() {
            return this._b;
        }
    }], [{
        key: "correctColor",
        value: function correctColor(color) {
            return !isNaN(color) || color < 0 ? 0 : color > 255 ? 255 : color;
        }
    }]);
    return ColorImpl;
}();
//# sourceMappingURL=EditorProperties.js.map
