import * as drawchat from "@s2study/draw-api";
import DrawchatLayers = drawchat.editor.DrawEditorLayers;
import DrawchatUpdater = drawchat.updater.DrawchatUpdater;
import DrawchatViewer = drawchat.viewer.DrawchatViewer;
import DrawchatEditor = drawchat.editor.DrawEditor;
import { EditorEventDispatchers } from "./EditorEventDispatchers";
export declare class Layers implements DrawchatLayers {
    updater: DrawchatUpdater;
    viewer: DrawchatViewer;
    editor: DrawchatEditor;
    currentId: string;
    private dispatcher;
    constructor(updater: DrawchatUpdater, viewer: DrawchatViewer, editor: DrawchatEditor, dispatcher: EditorEventDispatchers);
    layerCount(): Promise<number>;
    setCurrent(index: number): Promise<any>;
    getCurrent(): Promise<number>;
    show(index: number): void;
    hide(index: number): void;
    hideAll(): void;
    showAll(): void;
    remove(index: number): Promise<any>;
    addLayer(): Promise<any>;
    moveTo(index: number): Promise<any>;
    private getCurrentIndex();
    /**
     *
     * @param lastCurrentId
     * @param lastIndex
     * @returns {Promise<number>}
     */
    private noticeChangeCurrent(lastCurrentId, lastIndex);
}
