"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.ModeHandTool = undefined;

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ModeHandTool = exports.ModeHandTool = function () {
    function ModeHandTool(tran) {
        (0, _classCallCheck3.default)(this, ModeHandTool);

        this.tran = tran;
        this.tran.setSavePoint();
    }

    (0, _createClass3.default)(ModeHandTool, [{
        key: "touchStart",
        value: function touchStart(x, y) {
            if (!this.tran.isAlive()) {
                return;
            }
            this.tran.setSavePoint();
            this.sPointX = x;
            this.sPointY = y;
        }
    }, {
        key: "touchMove",
        value: function touchMove(x, y) {
            if (!this.tran.isAlive()) {
                return;
            }
            var latest = new Date().getTime();
            if (latest - this.time < 50) {
                this.wPointX = x;
                this.wPointY = y;
                this.setWait();
                return;
            }
            this.time = latest;
            this.setTranslate(x, y);
            // this.tran.restoreSavePoint();
            // this.tran.translate(x - this.sPointX,y - this.sPointY);
        }
    }, {
        key: "touchEnd",
        value: function touchEnd(x, y) {
            if (!this.tran.isAlive()) {
                return;
            }
            this.setTranslate(x, y);
            this.tran.commit(true);
            this.sPointX = null;
            this.sPointY = null;
        }
    }, {
        key: "setWait",
        value: function setWait() {
            var _this = this;

            if (this.waiting) {
                return;
            }
            this.waiting = true;
            setTimeout(function () {
                if (!_this.waiting) {
                    return;
                }
                _this.waiting = false;
                if (!_this.tran.isAlive()) {
                    return;
                }
                var now = new Date().getTime();
                if (now - _this.time < 100) {
                    _this.setWait();
                    return;
                }
                _this.setTranslate(_this.wPointX, _this.wPointY);
            }, 100);
        }
    }, {
        key: "setTranslate",
        value: function setTranslate(x, y) {
            this.waiting = false;
            if (this.sPointX == null || this.sPointY == null) {
                return;
            }
            // console.log(`endPoint(${x},${y}) startPoint(${this.sPointX},${this.sPointY})`);
            this.tran.translate(x - this.sPointX, y - this.sPointY);
            this.tran.flush();
        }
    }, {
        key: "setText",
        value: function setText(text) {
            // 処理しない。
        }
    }, {
        key: "backward",
        value: function backward() {
            // 処理しない。
        }
    }]);
    return ModeHandTool;
}();
//# sourceMappingURL=ModeHandTool.js.map
