"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.ModeText = undefined;

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ModeText = exports.ModeText = function () {
    function ModeText(viewer, tran, prop) {
        (0, _classCallCheck3.default)(this, ModeText);

        this.viewer = viewer;
        this.tran = tran;
        this.prop = prop;
        this.tran.setSavePoint();
    }

    (0, _createClass3.default)(ModeText, [{
        key: "touchStart",
        value: function touchStart(x, y) {
            if (!this.tran.isAlive()) {
                return;
            }
            this.pointX = x;
            this.pointY = y;
            this.drawText();
        }
    }, {
        key: "touchMove",
        value: function touchMove(x, y) {
            if (!this.tran.isAlive()) {
                return;
            }
            this.pointX = x;
            this.pointY = y;
            var latest = new Date().getTime();
            if (latest - this.time < 50) {
                this.setWait();
                return;
            }
            this.time = latest;
            this.drawText();
        }
    }, {
        key: "touchEnd",
        value: function touchEnd(x, y) {
            if (!this.tran.isAlive()) {
                return;
            }
            this.pointX = x;
            this.pointY = y;
            this.drawText();
        }
    }, {
        key: "setText",
        value: function setText(text) {
            if (!this.tran.isAlive()) {
                return;
            }
            this.text = text;
            this.drawText();
        }
    }, {
        key: "setWait",
        value: function setWait() {
            var _this = this;

            if (this.waiting) {
                return;
            }
            this.waiting = true;
            setTimeout(function () {
                if (!_this.waiting) {
                    return;
                }
                _this.waiting = false;
                if (!_this.tran.isAlive()) {
                    return;
                }
                var now = new Date().getTime();
                if (now - _this.time < 100) {
                    _this.setWait();
                    return;
                }
                _this.drawText();
            }, 100);
        }
    }, {
        key: "drawText",
        value: function drawText() {
            this.waiting = false;
            this.viewer.stop();
            try {
                this.tran.restoreSavePoint();
                this.tran.setSize(this.prop.fontSize);
                this.tran.setFontFamily(this.prop.fontFamily);
                // this.tran.setStrokeColor(`rgb(${this.prop.color.r},${this.prop.color.g},${this.prop.color.b},${this.prop.alpha})`);
                this.tran.setFill("rgba(" + this.prop.color.r + "," + this.prop.color.g + "," + this.prop.color.b + "," + this.prop.alpha + ")");
                this.tran.setPosition(this.pointX, this.pointY);
                this.tran.push(this.text);
            } finally {
                this.tran.flush();
                this.viewer.start();
            }
        }
    }, {
        key: "backward",
        value: function backward() {}
    }, {
        key: "forward",
        value: function forward() {}
    }]);
    return ModeText;
}();
//# sourceMappingURL=ModeText.js.map
