import * as drawchat from "@s2study/draw-api";
import PathTransaction = drawchat.updater.PathTransaction;
import { EditorProperties } from "./EditorProperties";
import { Point } from "./PointArray";
export declare class PathDrawer {
    /**
     * プロット数が多くなるので、使い回す。
     */
    private static SPLINE;
    private tran;
    private prop;
    constructor(tran: PathTransaction, prop: EditorProperties);
    pop(): Point;
    clear(): PathDrawer;
    push(x: number, y: number): PathDrawer;
    doPlot(closePath?: boolean, circle?: boolean): PathDrawer;
    /**
     * 円弧を描く
     */
    private firstCircle();
    /**
     * リストの大きさを計算してポイントの間引きを実施
     */
    private checkList();
    /**
     * リストポイントの間引きを実施
     */
    private cullList();
}
