"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.PathDrawer = undefined;

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _SplinePlotter = require("./SplinePlotter");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PathDrawer = exports.PathDrawer = function () {
    function PathDrawer(tran, prop) {
        (0, _classCallCheck3.default)(this, PathDrawer);

        this.tran = tran;
        // this.tran.setSavePoint();
        this.prop = prop;
        if (this.tran.isAlive()) {
            PathDrawer.SPLINE.inputList.init();
        }
    }

    (0, _createClass3.default)(PathDrawer, [{
        key: "pop",
        value: function pop() {
            if (this.tran.isAlive()) {
                PathDrawer.SPLINE.inputList.init();
            }
            if (PathDrawer.SPLINE.inputList.size() === 0) {
                return null;
            }
            var index = PathDrawer.SPLINE.inputList.size() - 1 | 0;
            var point = {
                x: PathDrawer.SPLINE.inputList.item(index).x,
                y: PathDrawer.SPLINE.inputList.item(index).y
            };
            PathDrawer.SPLINE.inputList.remove(index);
            return point;
        }
    }, {
        key: "clear",
        value: function clear() {
            if (this.tran.isAlive()) {
                PathDrawer.SPLINE.inputList.init();
            }
            return this;
        }
    }, {
        key: "push",
        value: function push(x, y) {
            this.checkList();
            if (PathDrawer.SPLINE.inputList.size() === 0) {
                PathDrawer.SPLINE.inputList.push(x, y);
                return this;
            }
            var point = PathDrawer.SPLINE.inputList.item(PathDrawer.SPLINE.inputList.item.length - 1);
            if (point.x === x && point.y === y) {
                return this;
            }
            PathDrawer.SPLINE.inputList.push(x, y);
            return this;
        }
    }, {
        key: "doPlot",
        value: function doPlot() {
            var closePath = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
            var circle = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

            var size = PathDrawer.SPLINE.inputList.size();
            if (size === 0) {
                return this;
            }
            if (size === 1 && circle) {
                this.firstCircle();
                return this;
            }
            if (closePath) {
                PathDrawer.SPLINE.inputList.push(PathDrawer.SPLINE.inputList.item(0).x, PathDrawer.SPLINE.inputList.item(0).y);
            }
            var addClose = size !== PathDrawer.SPLINE.inputList.size();
            PathDrawer.SPLINE.calc();
            var result = PathDrawer.SPLINE.resultList;
            // let result = PathDrawer.SPLINE.inputList;
            this.tran.moveTo(result.item(0).x, result.item(0).y);
            var i = 1 | 0;
            while (i < result.size()) {
                this.tran.lineTo(result.item(i).x, result.item(i).y);
                i = i + 1 | 0;
            }
            // console.log('パス描画 : '  + i);
            if (addClose) {
                PathDrawer.SPLINE.inputList.remove(PathDrawer.SPLINE.inputList.size() - 1);
            }
            return this;
        }
        /**
         * 円弧を描く
         */

    }, {
        key: "firstCircle",
        value: function firstCircle() {
            var radius = this.prop.thickness ? this.prop.thickness : 1;
            var x = PathDrawer.SPLINE.inputList.item(0).x;
            var y = PathDrawer.SPLINE.inputList.item(0).y;
            this.tran.moveTo(x - radius, y);
            this.tran.arcTo(x - radius, y + radius, x, y + radius, radius);
            this.tran.arcTo(x + radius, y + radius, x + radius, y, radius);
            this.tran.arcTo(x + radius, y - radius, x, y - radius, radius);
            this.tran.arcTo(x - radius, y - radius, x - radius, y, radius);
        }
        /**
         * リストの大きさを計算してポイントの間引きを実施
         */

    }, {
        key: "checkList",
        value: function checkList() {
            if (PathDrawer.SPLINE.inputList.size() + 1 === PathDrawer.SPLINE.inputList.max) {
                this.cullList();
            }
        }
        /**
         * リストポイントの間引きを実施
         */

    }, {
        key: "cullList",
        value: function cullList() {
            var len = PathDrawer.SPLINE.inputList.max;
            var i = len - 1;
            while (i >= 0) {
                if (i % 4 === 1) {
                    PathDrawer.SPLINE.inputList.remove(i);
                }
                i = i - 1 | 0;
            }
        }
    }]);
    return PathDrawer;
}();
/**
 * プロット数が多くなるので、使い回す。
 */


PathDrawer.SPLINE = new _SplinePlotter.SplinePlotter();
//# sourceMappingURL=PathDrawer.js.map
