"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.PointList = undefined;

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _FixSizeArray = require("./FixSizeArray");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PointFactory = function () {
    function PointFactory() {
        (0, _classCallCheck3.default)(this, PointFactory);
    }

    (0, _createClass3.default)(PointFactory, [{
        key: "createInstance",
        value: function createInstance(index, typedArray) {
            return new PointImpl(typedArray, index);
        }
    }]);
    return PointFactory;
}();
/**
 * Point の実装。
 * 内部的にTypedArrayを参照しており、
 * PointList上でRemoveされた場合の参照は残るためインスタンスの使い回しには注意する。
 */


var PointImpl = function () {
    function PointImpl(array, index) {
        (0, _classCallCheck3.default)(this, PointImpl);

        this.array = array;
        this.index = index;
    }

    (0, _createClass3.default)(PointImpl, [{
        key: "x",
        get: function get() {
            return this.array[2 * this.index];
        },
        set: function set(val) {
            this.array[2 * this.index] = val;
        }
    }, {
        key: "y",
        get: function get() {
            return this.array[2 * this.index + 1];
        },
        set: function set(val) {
            this.array[2 * this.index + 1] = val;
        }
    }]);
    return PointImpl;
}();
/**
 * 固定長サイズのリスト
 */


var PointList = exports.PointList = function (_Float32ItemArray) {
    (0, _inherits3.default)(PointList, _Float32ItemArray);

    function PointList(size) {
        (0, _classCallCheck3.default)(this, PointList);
        return (0, _possibleConstructorReturn3.default)(this, (PointList.__proto__ || Object.getPrototypeOf(PointList)).call(this, 2, size, new PointFactory()));
    }

    (0, _createClass3.default)(PointList, [{
        key: "push",
        value: function push() {
            var x = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
            var y = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

            if (this.len + 1 === this.max) {
                throw new Error("Array index out of range.");
            }
            this.list[this.len].x = x;
            this.list[this.len].y = y;
            this.len = this.len + 1 | 0;
            return this.list[this.len - 1 | 0];
        }
    }, {
        key: "set",
        value: function set(index, x, y) {
            if (index > this.len + 1) {
                throw new Error("Array index out of range.");
            }
            this.list[index].x = x;
            this.list[index].y = y;
            if (this.len === index) {
                this.len = index;
            }
            return this.list[index];
        }
    }]);
    return PointList;
}(_FixSizeArray.Float32ItemArray);
//# sourceMappingURL=PointArray.js.map
