"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.SplinePlotter = undefined;

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _FixSizeArray = require("./FixSizeArray");

var _PointArray = require("./PointArray");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * ２次ベジェスプライン曲線をプロットするクラス
 * コードは以下のサイトから引用
 *
 * http://hakuhin.jp/as/curve.html#CURVE_04
 */
var SplinePlotter = exports.SplinePlotter = function () {
    function SplinePlotter() {
        var cashSize = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1000;
        var optCount = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 20;
        (0, _classCallCheck3.default)(this, SplinePlotter);

        this.optCount = optCount | 0;
        this._A = new _FixSizeArray.Float32ItemArray(3, cashSize, new TripleItemFactory());
        this._B = new _PointArray.PointList(cashSize);
        this._C = new _PointArray.PointList(cashSize);
        this.l = new Float32Array(cashSize);
        this.result = new _PointArray.PointList(cashSize * optCount);
        this.input = new _PointArray.PointList(cashSize);
    }

    (0, _createClass3.default)(SplinePlotter, [{
        key: "calc",

        /**
         * スプライン曲線描画用の座標を取得します。
         */
        value: function calc() {
            var num = this.input.size();
            var i = 0 | 0;
            var j = i | 0;
            while (j < (num - 1 | 0)) {
                var p0 = this.input.item(i);
                var p1 = this.input.item(i + 1);
                var lenX = p0.x - p1.x;
                var lenY = p0.y - p1.y;
                j = j + 1 | 0;
                if (lenX === 0 && lenY === 0) {
                    this.input.remove(i);
                    continue;
                }
                // this.l[i] = (lenX === 0 || lenY === 0) ? 0 : Math.sqrt(lenX * lenX + lenY * lenY);
                this.l[i] = Math.sqrt(lenX * lenX + lenY * lenY);
                i = i + 1 | 0;
            }
            num = i + 1 | 0;
            this._A.init(num);
            this._B.init(num);
            this._C.init(num);
            if (num <= 1) {
                this.result.init();
                return;
            }
            this._A.item(0).i1 = 0;
            this._A.item(0).i2 = 1;
            this._A.item(0).i3 = 0.5;
            this._B.set(0, 3 / (2 * this.l[0]) * this.convertNaN(this.input.item(1).x - this.input.item(0).x), 3 / (2 * this.l[0]) * this.convertNaN(this.input.item(1).y - this.input.item(0).y));
            this._A.item(num - 1).i1 = 1;
            this._A.item(num - 1).i2 = 2;
            this._A.item(num - 1).i3 = 0;
            this._B.set(num - 1, 3 / this.l[num - 2] * this.convertNaN(this.input.item(num - 1).x - this.input.item(num - 2).x), 3 / this.l[num - 2] * this.convertNaN(this.input.item(num - 1).y - this.input.item(num - 2).y));
            var a = void 0;
            i = 1 | 0;
            while (i < (num - 1 | 0)) {
                a = this.l[i - 1];
                var b = this.l[i];
                this._A.item(i).i1 = b;
                this._A.item(i).i2 = 2.0 * (b + a);
                this._A.item(i).i3 = a;
                this._B.set(i, (3.0 * (a * a * (this.input.item(i + 1).x - this.input.item(i).x)) + 3.0 * b * b * (this.input.item(i).x - this.input.item(i - 1).x)) / this.convertNaN(b * a), (3.0 * (a * a * (this.input.item(i + 1).y - this.input.item(i).y)) + 3.0 * b * b * (this.input.item(i).y - this.input.item(i - 1).y)) / this.convertNaN(b * a));
                i = i + 1 | 0;
            }
            i = 1 | 0;
            while (i < (num | 0)) {
                var d = this._A.item(i - 1).i2 / this._A.item(i).i1;
                this._A.item(i).i1 = 0;
                this._A.item(i).i2 = this._A.item(i).i2 * d - this._A.item(i - 1).i3;
                this._A.item(i).i3 = this._A.item(i).i3 * d;
                this._B.set(i, (this._B.item(i).x * d - this._B.item(i - 1).x) / this._A.item(i).i2, (this._B.item(i).y * d - this._B.item(i - 1).y) / this._A.item(i).i2);
                this._A.item(i).i3 = this._A.item(i).i3 / this._A.item(i).i2;
                this._A.item(i).i2 = 1;
                i = i + 1 | 0;
            }
            this._C.set(num - 1, this._B.item(num - 1).x, this._B.item(num - 1).y);
            j = num - 1 | 0;
            while (j > 0) {
                this._C.set(j - 1, this._B.item(j - 1).x - this._A.item(j - 1).i3 * this._C.item(j).x, this._B.item(j - 1).y - this._A.item(j - 1).i3 * this._C.item(j).y);
                j = j - 1 | 0;
            }
            this.result.init(0);
            var _00 = void 0;
            var _01 = void 0;
            var _02 = void 0;
            var _03 = void 0;
            var _10 = void 0;
            var _11 = void 0;
            var _12 = void 0;
            var _13 = void 0;
            i = 0 | 0;
            while (i < (num - 1 | 0)) {
                a = this.l[i];
                _00 = this.input.item(i).x;
                _01 = this._C.item(i).x;
                _02 = (this.input.item(i + 1).x - this.input.item(i).x) * 3 / (a * a) - (this._C.item(i + 1).x + 2 * this._C.item(i).x) / a;
                _03 = (this.input.item(i + 1).x - this.input.item(i).x) * (-2 / (a * a * a)) + (this._C.item(i + 1).x + this._C.item(i).x) * (1 / (a * a));
                _10 = this.input.item(i).y;
                _11 = this._C.item(i).y;
                _12 = (this.input.item(i + 1).y - this.input.item(i).y) * 3 / (a * a) - (this._C.item(i + 1).y + 2 * this._C.item(i).y) / a;
                _13 = (this.input.item(i + 1).y - this.input.item(i).y) * (-2 / (a * a * a)) + (this._C.item(i + 1).y + this._C.item(i).y) * (1 / (a * a));
                var t = 0;
                j = 0 | 0;
                while (j < this.optCount) {
                    this.result.push(((_03 * t + _02) * t + _01) * t + _00, ((_13 * t + _12) * t + _11) * t + _10);
                    t += a / this.optCount;
                    j = j + 1 | 0;
                }
                i = i + 1 | 0;
            }
            this.result.push(this.input.item(num - 1).x, this.input.item(num - 1).y);
        }
    }, {
        key: "convertNaN",
        value: function convertNaN(num) {
            return num === 0 ? 0.001 : num;
        }
    }, {
        key: "resultList",
        get: function get() {
            return this.result;
        }
    }, {
        key: "inputList",
        get: function get() {
            return this.input;
        }
    }]);
    return SplinePlotter;
}();

var TripleItemFactory = function () {
    function TripleItemFactory() {
        (0, _classCallCheck3.default)(this, TripleItemFactory);
    }

    (0, _createClass3.default)(TripleItemFactory, [{
        key: "createInstance",
        value: function createInstance(index, typedArray) {
            return new Triple(typedArray, index);
        }
    }]);
    return TripleItemFactory;
}();
/**
 * Point の実装。
 * 内部的にTypedArrayを参照しており、
 * PointList上でRemoveされた場合の参照は残るためインスタンスの使い回しには注意する。
 */


var Triple = function () {
    function Triple(array, index) {
        (0, _classCallCheck3.default)(this, Triple);

        this.array = array;
        this.index = index;
    }

    (0, _createClass3.default)(Triple, [{
        key: "i1",
        get: function get() {
            return this.array[3 * this.index];
        },
        set: function set(val) {
            this.array[3 * this.index] = val;
        }
    }, {
        key: "i2",
        get: function get() {
            return this.array[3 * this.index + 1];
        },
        set: function set(val) {
            this.array[3 * this.index + 1] = val;
        }
    }, {
        key: "i3",
        get: function get() {
            return this.array[3 * this.index + 2];
        },
        set: function set(val) {
            this.array[3 * this.index + 2] = val;
        }
    }]);
    return Triple;
}();
//# sourceMappingURL=SplinePlotter.js.map
